import { Injector, Type, Provider } from '@angular/core';
export interface IReflector {
    annotations(type: Type<any>): Array<Type<any>>;
}
export declare class DecoratorsHelper {
    private reflector;
    constructor(reflector: IReflector);
    hasDecorator(type: Type<any>, annotation: (...args: any[]) => (cls: any) => any): boolean;
    findDecorator(type: Type<any>, annotation: (...args: any[]) => (cls: any) => any): boolean;
}
export interface IServiceLocator {
    getService<TService>(ctor: {
        new (...type: Type<any>[]): TService;
    }): TService;
    createService<TService>(ctor: {
        new (...type: Type<any>[]): TService;
    }): TService;
    configure(providers: Provider[]): any;
}
export declare class ServiceLocator implements IServiceLocator {
    protected injector: Injector;
    protected decoratorsHelper: DecoratorsHelper;
    private providers;
    constructor(injector: Injector, decoratorsHelper: DecoratorsHelper);
    /**
     * @override
     */
    configure(providers: Provider[]): void;
    /**
     * @override
     */
    getService<TService>(ctor: {
        new (...type: Type<any>[]): TService;
    }): TService;
    /**
     * @override
     */
    createService<TService>(ctor: {
        new (...type: Type<any>[]): TService;
    }): TService;
}
