"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var core_3 = require('@angular/core');
var decorators_1 = require('./decorators');
var DecoratorsHelper = (function () {
    function DecoratorsHelper(reflector) {
        this.reflector = reflector;
    }
    DecoratorsHelper.prototype.hasDecorator = function (type, annotation) {
        return !!this.findDecorator(type, annotation);
    };
    DecoratorsHelper.prototype.findDecorator = function (type, annotation) {
        return !!this.reflector.annotations(type)
            .find(function (type) { return type instanceof annotation; });
    };
    DecoratorsHelper = __decorate([
        core_1.Injectable(),
        __param(0, core_1.Inject(core_3.__core_private__.Reflector)), 
        __metadata('design:paramtypes', [Object])
    ], DecoratorsHelper);
    return DecoratorsHelper;
}());
exports.DecoratorsHelper = DecoratorsHelper;
var ServiceLocator = (function () {
    function ServiceLocator(injector, decoratorsHelper) {
        this.injector = injector;
        this.decoratorsHelper = decoratorsHelper;
    }
    /**
     * @override
     */
    ServiceLocator.prototype.configure = function (providers) {
        this.providers = providers;
    };
    /**
     * @override
     */
    ServiceLocator.prototype.getService = function (ctor) {
        return this.decoratorsHelper.hasDecorator(ctor, decorators_1.Singleton)
            ? this.injector.get(ctor) // Get a current singleton instance
            : this.createService(ctor);
    };
    /**
     * @override
     */
    ServiceLocator.prototype.createService = function (ctor) {
        var ctorProviders = [];
        if (Array.isArray(this.providers)) {
            ctorProviders = ctorProviders.concat(this.providers);
            if (this.providers.find(function (provider) { return (provider === ctor) || provider.provide === ctor; })) {
            }
            else {
                ctorProviders.push(ctor);
            }
        }
        else {
            ctorProviders.push(ctor);
        }
        return core_2.ReflectiveInjector.resolveAndCreate(ctorProviders, this.injector).get(ctor); // Create a new instance every time using existing dependencies.
    };
    ServiceLocator = __decorate([
        core_1.Injectable(),
        __param(0, core_1.Inject(core_1.Injector)),
        __param(1, core_1.Inject(DecoratorsHelper)), 
        __metadata('design:paramtypes', [core_1.Injector, DecoratorsHelper])
    ], ServiceLocator);
    return ServiceLocator;
}());
exports.ServiceLocator = ServiceLocator;
//# sourceMappingURL=ServiceLocator.js.map